<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\master_worker_customer;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\master_worker_customer\MasterWorkerCustomer;
use app\common\lists\ListsSearchInterface;


/**
 * MasterWorkerCustomer列表
 * Class MasterWorkerCustomerLists
 * @package app\adminapi\listsmaster_worker_customer
 */
class MasterWorkerCustomerLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/10 17:34
     */
    public function setSearch(): array
    {
        return [
            '=' => ['worker_id',  'admin_id', 'status'],
            '%like%' => ['name', 'mobile'],
        ];
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/10 17:34
     */
    public function lists(): array
    {
        return MasterWorkerCustomer::with(['admin','masterWorker'])
            ->where($this->searchWhere)
            ->where($this->queryWhere())
            ->field(['id','worker_id','admin_id','name', 'mobile', 'problem', 'status', 'remark'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }

    public function queryWhere():array
    {
        $where = [];
        // 用户
        if (isset($this->params['worker_id']) && is_array($this->params['worker_id'])) {
            $where[] = ['user_id', 'in',$this->params['user_id']];
        }
        if (isset($this->params['admin_id']) && is_array($this->params['admin_id'])) {
            $where[] = ['admin_id', 'in',$this->params['admin_id']];
        }
        if(isset($this->params['create_time']) && !empty($this->params['create_time'])){
            $time = [strtotime($this->params['create_time'][0]), strtotime($this->params['create_time'][1])];
            $where[] = ['create_time', 'between', $time];
        }
        if(isset($this->params['update_time']) && !empty($this->params['update_time'])){
            $time = [strtotime($this->params['update_time'][0]), strtotime($this->params['update_time'][1])];
            $where[] = ['update_time', 'between', $time];
        }
        return $where;
    }

    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/10 17:34
     */
    public function count(): int
    {
        return MasterWorkerCustomer::where($this->searchWhere)->where($this->queryWhere())->count();
    }
}